//+------------------------------------------------------------------+
//|                                                      CTG_Map.mq4 |
//|                                                CompanyName "CTG" |
//|                                     http://chaostradinggroup.com |
//+------------------------------------------------------------------+
#property copyright "CTG"
#property link      "http://chaostradinggroup.com"

#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1 Pink
#property indicator_color2 LimeGreen
#property indicator_color3 Red
#property indicator_color4 Gray
#property indicator_color5 Green
#property indicator_color6 Green
#property indicator_color7 Green
#property indicator_color8 Blue


//---- indicator parameters
extern int MA_Period=8;
extern int MA_Shift=0;
extern int MA_Method=0;
extern double k1=1.5;
//---- indicator buffers
double ExtMapBuffer[];
double ExtGistBuffer[];
double ExtRistBuffer[];
double ExtBullBuffer[];
double ExtBearBuffer[];
double ExtZedBuffer[];
double ExtGist1Buffer[];
double ExtRist1Buffer[];
double b,b1;
//----
int ExtCountedBars=0,limit,s0,s1,r,s2,s3,s4;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   int    draw_begin;
   string short_name;
//---- drawing settings

SetIndexStyle(0,DRAW_HISTOGRAM,EMPTY, 4,C'255,215,210');
   SetIndexEmptyValue(0,0.0);
   SetIndexShift(0,MA_Shift);   
SetIndexStyle(1,DRAW_HISTOGRAM,EMPTY, 4,PaleGreen );
   SetIndexEmptyValue(1,0.0);
   SetIndexShift(1,MA_Shift); 
SetIndexStyle(2,DRAW_HISTOGRAM,EMPTY, 4, C'255,117,117');
   SetIndexEmptyValue(2,0.0);
   SetIndexShift(2,MA_Shift);   
SetIndexStyle(3,DRAW_LINE,EMPTY, 1,Gray );
  SetIndexDrawBegin(3,0);
  // SetIndexEmptyValue(3,0.0);   
   SetIndexShift(3,MA_Shift);   
   SetIndexStyle(4,DRAW_LINE);
   SetIndexEmptyValue(4,0.0); 
   SetIndexShift(4,MA_Shift);
   SetIndexStyle(5,DRAW_HISTOGRAM,EMPTY, 4,LimeGreen );
   SetIndexEmptyValue(5,0.0); 
   SetIndexShift(5,MA_Shift);   
   SetIndexStyle(6,DRAW_LINE);
   SetIndexEmptyValue(6,0.0); 
   SetIndexShift(6,MA_Shift);
   SetIndexStyle(7,DRAW_LINE);
  // SetIndexEmptyValue(7,0.0); 
   SetIndexShift(7,MA_Shift); 
   
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
   if(MA_Period<2) MA_Period=2;
   draw_begin=MA_Period-1;
//---- indicator short name

         short_name="CTG-Map(";

   IndicatorShortName(short_name+MA_Period+")");
   SetIndexDrawBegin(0,draw_begin);
//---- indicator buffers mapping
   SetIndexBuffer(0,ExtGistBuffer);   
   SetIndexBuffer(1,ExtRistBuffer); 
   SetIndexBuffer(2,ExtGist1Buffer);   
   SetIndexBuffer(3,ExtRist1Buffer);    
   SetIndexBuffer(4,ExtBearBuffer);   
   SetIndexBuffer(5,ExtZedBuffer);   
   SetIndexBuffer(6,ExtBullBuffer);   
   SetIndexBuffer(7,ExtMapBuffer);   
 //---- index labels
   SetIndexLabel(0,"Red zone light");
   SetIndexLabel(1,"Green zone light");
   SetIndexLabel(2,"Red zone");
   SetIndexLabel(3,NULL);
   SetIndexLabel(4,NULL);
   SetIndexLabel(5,"Green zone");  
   SetIndexLabel(6,"Bars Size");  
   SetIndexLabel(7,NULL);     
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   if(Bars<=MA_Period) return(0);
   ExtCountedBars=IndicatorCounted()-1;
//---- check for possible errors
//  if (ExtCountedBars<0) return(-1);
//---- last counted bar will be recounted
   if (ExtCountedBars>1) ExtCountedBars--;
    // else ExtCountedBars=0;
     //----

  limit=Bars-ExtCountedBars;
//---- done




for(s1=0; s1<=limit; s1++)
{
if (s1==0)
{
ExtGistBuffer[s1]=0;
ExtGist1Buffer[s1]=0;
ExtZedBuffer[s1]=0;
ExtRistBuffer[s1]=0;

}

ExtBullBuffer[s1]=(iMA(NULL,0,MA_Period,MA_Shift,MA_Method,2,s1)-iMA(NULL,0,MA_Period,MA_Shift,MA_Method,3,s1));
ExtBearBuffer[s1]=-ExtBullBuffer[s1];

ExtMapBuffer[s1]=((iMA(NULL,0,MA_Period,MA_Shift,MA_Method,0,s1)-iMA(NULL,0,MA_Period,MA_Shift,MA_Method,0,s1+1)))*k1;
ExtRist1Buffer[s1]=-ExtMapBuffer[s1];


}

for(s0=0; s0<=limit; s0++)
{

if (ExtMapBuffer[s0]> ExtMapBuffer[s0+1] && ExtMapBuffer[s0] > 0){ExtZedBuffer[s0]=ExtMapBuffer[s0];}   
if (ExtMapBuffer[s0]<= ExtMapBuffer[s0+1] && ExtMapBuffer[s0] > 0){ExtRistBuffer[s0]=ExtMapBuffer[s0];}

 
if (ExtMapBuffer[s0]<ExtMapBuffer[s0+1] && ExtMapBuffer[s0] < 0)
   {
     ExtGist1Buffer[s0]=ExtMapBuffer[s0];
   }
if (ExtMapBuffer[s0]>=ExtMapBuffer[s0+1] && ExtMapBuffer[s0] < 0)
   {
     ExtGistBuffer[s0]=ExtMapBuffer[s0];
   }

}








return(0);
}


